/* OscThread -- thread for making an oscillator go go go
 *	this one has a filter!
 *
 * 		Brad Garton, spring 2003
 *
*/
import com.softsynth.jsyn.*;

class OscThread extends Thread
{
	SquareOscillator	theOsc;
	LineOut			oscOut;
	Filter_LowPass		mellow;

	public OscThread() throws SynthException
	{
		theOsc = new SquareOscillator();
		oscOut = new LineOut();
		mellow = new Filter_LowPass();

		// note how we chain the inputs and outputs of the different
		// ugens below
		theOsc.output.connect(mellow.input);
		mellow.output.connect(0, oscOut.input, 0);
		mellow.output.connect(0, oscOut.input, 1);

		theOsc.amplitude.set(0.5);
		theOsc.frequency.set(252.0);

		mellow.amplitude.set(1.0);
		mellow.frequency.set(1000.0);
		mellow.Q.set(10.0);
	}

	public void run()
	{
		try
		{
			theOsc.start();
			oscOut.start();
			mellow.start();
		} catch(SynthException e) {
			SynthAlert.showError(e);
		}
	}
}
